#!/usr/bin/perl
# =====================================================
#
# questionnaire-analysis - Program for the automation of the analysis of the results of a questionnaire.
#
# Copyright (C) 2011 Vladimir B. Tsarkov
#
# This file is part of questionnaire-analysis.
#
# questionnaire-analysis is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# questionnaire-analysis is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with questionnaire-analysis. If not, see <http://www.gnu.org/licenses/>.
#
# ------
#
#  You can contact me via e-mail: lipetsk-gnu-lug at bk period ru
#
#  q1-short.pl
#
#  Abstract: Deals with the questions that have 2 variants of answers.
#  Работает с вопросами, которые имеют 2 варианта ответов.
#
#  Revision History:
#     1  2011-06-09  vbt
#
# =====================================================
#
# Программа может быть остановлена нажатием
# комбинации клавиш Ctrl+C.

# The function takes the answers
# to the questions and writes it
# to arrays. Each array represents
# a factor of the formation of the
# readiness to selfeducation.

# Функция получает ответы на вопросы
# и помещает их в массивы.
# Каждый массив соответствует фактору
# формирования готовности к самообразованию.

sub feval
{

#	@result[$i] = $_[0];

# $p helds the number of the question
# that is being processed.
# Переменная $p содержит номер обрабатываемого вопроса.

	$p = $_[4];
	@Adifpsyfiz[$p] = $_[0];
	@Bpsy[$p] = $_[1];
	@Csoceconom[$p] = $_[2];
	@Dsocpsy[$p] = $_[3];
}

for($i=0; $i<=10; $i++)
{
	$q = $i+2;
	print "\n"; 
	print "Question $q: ";
	defined($input = <STDIN>);
   
	if($input =~ /a|b/){

		if(($i+2)==2)
		{
			# Вы привыкли работать с текстом книги по определённому плану?
			# (психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,1,0,0,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

   	if(($i+2)==3)
		{
			# У Вас есть однокурсники, с которыми Вы сообща принимаете
			# участие в учебных делах (вместе готовитесь к занятиям и т.п.)?
			# (социально-психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,0,0,1,$i);}
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

	   if(($i+2)==4)
		{
			# Вы занимаетесь самообразованием регулярно и без принуждения?
			# (психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,1,0,0,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

   	if(($i+2)==5)
		{
			# Вы делаете утреннюю зарядку регулярно? 
			# (психологический)		
	
			if($input =~ /a/){@result[$i] = 1; feval(1,1,0,0,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

   	if(($i+2)==6)
		{
			# Часто ли Вы впадаете в депрессию?
			# (дифференциально-психофизиологический)
			# (психологический)

			if($input =~ /a/){@result[$i] = 0; feval(0,0,0,0,$i);}  
			if($input =~ /b/){@result[$i] = 1; feval(1,1,0,0,$i);} 
		}

   	if(($i+2)==7)
		{
			# Нужно ли Вам осмысленно регулировать потоки информации,
			# идущие на Вас?
			# (психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,1,0,0,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

	   if(($i+2)==8)
		{
			# Вы хотя бы раз публиковали собственную статью или
			# перевод в Интернет?
			# (психологический)
			# (социально-психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,1,0,1,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

   	if(($i+2)==9)
		{
			# Вы хотя бы раз консультировали своих друзей по учебным вопросам?
			# (социально-психологический)
			# (психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,1,0,1,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

	   if(($i+2)==10)
		{
			# Случалось ли, что Вы, прочитав библиотечный учебник или
			# монографию, приобретали в магазине такую же книгу для
			# своей домашней библиотеки?
			# (социально-экономический)
			# (психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,1,1,0,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

		if(($i+2)==11)
		{
			# Считают ли Ваши родственники, что МИКТ/ЛГПУ - это
			# хорошее учебное заведение?
			# (социально-психологический)		
	
			if($input =~ /a/){@result[$i] = 1; feval(0,0,0,1,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}

   	if(($i+2)==12)
		{
			# Интересно ли Вам обсуждать научные проблемы с однокурсниками
			# и преподавателем?
			# (социально-психологический)

			if($input =~ /a/){@result[$i] = 1; feval(0,0,0,1,$i);}  
			if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
		}
	} 
	else 
	{
		print "Only a or b are allowed\n";
   }
}
	$out = 0;
	$As = 0;
	$Bs = 0;
	$Cs = 0;
	$Ds = 0;

for($j=0; $j<=10; $j++)
{

#	print @result[$j];
#	print "\n";

	$out = $out + @result[$j];
	$As = $As + $Adifpsyfiz[$j];
	$Bs = $Bs + $Bpsy[$j];
	$Cs = $Cs + $Csoceconom[$j];
	$Ds = $Ds + $Dsocpsy[$j];
}

print "=====================\n";
print "The result is: $out out of 11\n";

$percent = ($out/11) * 100;
print "The percentage is: $percent\n";

# 2 вопроса
print "A = $As out of 2\n";
$Aper = $As*100/2;
print "Dif-psy-physiological factor: $Aper percent\n";

# 8 вопросов
print "B = $Bs out of 8\n";
$Bper = $Bs*100/8;
print "Psychological factor: $Bper percent\n";

# 1 вопрос
print "C = $Cs out of 1\n";
$Cper = $Cs*100/1;
print "Socio-economical factor: $Cper percent\n";

# 5 вопросов
print "D = $Ds out of 5\n";
$Dper = $Ds*100/5;
print "Socio-psychological factor: $Dper percent\n";

print "Overall result in the first part of questionary is: ";
$all = ($Aper + $Bper + $Cper + $Dper)/4;
print "$all percent\n";


