#!/usr/bin/perl
# =====================================================
#
# questionnaire-analysis - Program for the automation of the analysis of the results of a questionnaire.
#
# Copyright (C) 2011 Vladimir B. Tsarkov
#
# This file is part of questionnaire-analysis.
#
# questionnaire-analysis is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# questionnaire-analysis is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with questionnaire-analysis. If not, see <http://www.gnu.org/licenses/>.
#
# ------
#
#  You can contact me via e-mail: lipetsk-gnu-lug at bk period ru
#
#  q2-short.pl
#
#  Abstract: Deals with the questions that have 3 variants of answers.
#  Работает с вопросами, которые имеют 3 варианта ответов.
#
#  Revision History:
#     1  2011-06-09  vbt
#
# =====================================================
#
# Программа может быть остановлена нажатием
# комбинации клавиш Ctrl+C.

sub feval
{

#       @result[$i] = $_[0];

        $p = $_[4];
        @Adifpsyfiz[$p] = $_[0];
        @Bpsy[$p] = $_[1];
        @Csoceconom[$p] = $_[2];
        @Dsocpsy[$p] = $_[3];
}

for($i=0; $i<=2; $i++)
{
	$q = $i+1; 
	print "\n";
	print "Question $q: ";
	defined($input = <STDIN>);
		if($input =~ /a|b|c/)
		{

			if(($i+1)==1)
			{
				# Какова обычно Ваша реакция на необходимость
				# признать свою ошибку перед окружающими?
				# (психологический)

				if($input =~ /a/){@result[$i] = 1; feval(0,1,0,0,$i);}  
				if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
				if($input =~ /c/){@result[$i] = 0.5; feval(0,0.5,0,0,$i);} 
			}

	      if(($i+1)==2)
			{
				# Хватает ли Вам денежных средств на покупку всех нужных книг?
				# (социально-экономический)

				if($input =~ /a/){@result[$i] = 1; feval(0,0,1,0,$i);}  
				if($input =~ /b/){@result[$i] = 0.5; feval(0,0,0.5,0,$i);} 
				if($input =~ /c/){@result[$i] = 0; feval(0,0,0,0,$i);} 
			}

			if(($i+1)==3)
			{
				# Каким образом Вы делаете конспекты?
				# (психологический)

				if($input =~ /a/){@result[$i] = 0.5; feval(0,0.5,0,0,$i);}  
				if($input =~ /b/){@result[$i] = 0; feval(0,0,0,0,$i);} 
				if($input =~ /c/){@result[$i] = 1; feval(0,1,0,0,$i);} 
			}
      } else {
			print "Only a or b or c are allowed\n";
      }
}

	$out = 0;

	$As = 0;
	$Bs = 0;
	$Cs = 0;
	$Ds = 0;

for($j=0; $j<=2; $j++)
{

#       print @result[$j];
#       print "\n";

	$out = $out + @result[$j];
	$As = $As + $Adifpsyfiz[$j];
	$Bs = $Bs + $Bpsy[$j];
	$Cs = $Cs + $Csoceconom[$j];
	$Ds = $Ds + $Dsocpsy[$j];
}

print "=====================\n";
print "The result is: $out out of 3\n";

$percent = ($out/3) * 100;
print "The percentage is: $percent\n";

# 0 вопросов
#print "A = $As out of 0\n";
#$Aper = $As*100/1;
#print "Dif-psy-physiological factor: $Aper percent\n";

# 2 вопроса
print "B = $Bs out of 2\n";
$Bper = $Bs*100/2;
print "Psychological factor: $Bper percent\n";

# 1 вопрос
print "C = $Cs out of 1\n";
$Cper = $Cs*100/1;
print "Socio-economical factor: $Cper percent\n";

# 0 вопросов
#print "D = $Ds out of 0\n";
#$Dper = $Ds*100/1;
#print "Socio-psychological factor: $Dper percent\n";

print "Overall result in the second part of questionary is: ";
$all = ($Bper + $Cper)/2;
print "$all percent\n";
